﻿#
# 2023.12 株式会社　シンタ
#
#引数をそれぞれ格納
# 1.SheetPA実行用のExcelファイルパス
# 2.SheetPA実行用のシート名
# 3.SheetPA実行用のExcelファイル名
param(
    [string]$Arg1,
    [string]$Arg2,
    [string]$Arg3
)

# 引数のパスを取得
$WB_PATH = $Arg1

# Excelアプリケーションの作成
$excelApp = New-Object -ComObject Excel.Application
$excelApp.Visible = $true
# Excelを最大化
$excelApp.WindowState = [Microsoft.Office.Interop.Excel.XlWindowState]::xlMaximized

# ワークブックのオープン
$workbook = $excelApp.Workbooks.Open($WB_PATH)


# SheetPAを実行するシートの選択
$worksheet = $workbook.Sheets.Item($Arg2)
$worksheet.Activate()

# タスクの終了まで待機
Start-Sleep -Seconds 3

# Excelを最前面に表示。
# 対象となるウインドウの名称を指定
add-type -assembly microsoft.visualbasic
[microsoft.visualbasic.interaction]::AppActivate($Arg3)

# キー操作によってアドインタブを選択し、SheetPAを起動する
#  ※ Excelのバージョンや追加されているアドイン、拡張機能によって操作するキーが変更になる場合がある
Add-Type -AssemblyName System.Windows.Forms
# Alt を送信
[System.Windows.Forms.SendKeys]::SendWait("%")
# X を送信
[System.Windows.Forms.SendKeys]::SendWait("X")
# Y1 を送信
[System.Windows.Forms.SendKeys]::SendWait("Y1")

# SheetPAの起動完了まで待機
#  ※ PCのスペック等によって待機時間が変更になる可能性がある
Start-Sleep -Seconds 20

# キー操作によって、SheetPAを実行する
#  ※ Excelのバージョンや追加されているアドイン、拡張機能によって操作するキーが変更になる場合がある
# Alt を送信
[System.Windows.Forms.SendKeys]::SendWait("%")
# X を送信
[System.Windows.Forms.SendKeys]::SendWait("X")
# YF を送信
[System.Windows.Forms.SendKeys]::SendWait("YF")

# 確認ポップアップ起動まで待機
Start-Sleep -Seconds 5
[System.Windows.Forms.SendKeys]::SendWait("{ENTER}")
